# Docker
On all Nodes

> More about docker engine installation: https://docs.docker.com/engine/install/ubuntu/

```
$ sudo -i
$ apt update
$ apt install \
    ca-certificates \
    curl
$ curl -fsSL https://download.docker.com/linux/ubuntu/gpg -o /etc/apt/keyrings/docker.asc
$ chmod a+r /etc/apt/keyrings/docker.asc
$ echo \
    "deb [arch=$(dpkg --print-architecture) signed-by=/etc/apt/keyrings/docker.asc] https://download.docker.com/linux/ubuntu \
    $(. /etc/os-release && echo ""${UBUNTU_CODENAME:-$VERSION_CODENAME}") stable" | \
    tee /etc/apt/source.list.d/docker.list > /dev/null
$ apt update
$ apt install docker-ce docker-ce-cli containerd.io docker-buildx-plugin docker-compose-plugin
```

Additional HDD (96GB) for docker images and running container (Our root disk with 32GB has not enough free space)
```
# lshw -class disk -short
# parted /dev/sdc mklabel gpt
# parted -a opt /dev/sdc mkpart primary 0% 100%
# parted -s -- /dev/sdc set 1 lvm on
# parted /dev/sdc print
# pvcreate --dataalignment 128K /dev/sdc1
# vgcreate --physicalextentsize 128K data_vg /dev/sdc1
# lvcreate -L 4G --name data_pool_meta data_vg
# lvcreate -L 80G --name data_pool data_vg
# lvconvert --chunksize 128K --thinpool data_vg/data_pool --poolmetadata data_vg/data_pool_meta
# lvchange --zero n data_vg/data_pool
# lvcreate -V 80G -T data_vg/data_pool -n data_lv
# mkfs.xfs -f -i size=512 -n size=8192 -d su=128k,sw=1 /dev/data_vg/data_lv
# mkdir -pv /opt/oea/data
# echo "echo '/dev/data_vg/data_lv /opt/oea/data xfs defaults 1 2' >> /etc/fstab" | sudo -s
# mount -a
```

Docker Configuration
```
$ sudo mkdir -pv /opt/oea/data/docker
$ sudo mkdir -v /etc/systemd/system/docker.service.d
$ sudo -i
# touch /etc/systemd/system/docker.service.d/docker-storage.conf
# echo '[Service]' >> /etc/systemd/system/docker.service.d/docker-storage.conf
# echo 'ExecStart=/usr/bin/dockerd -H fd:// --data-root="/opt/oea/data/docker"' >> /etc/systemd/system/docker.service.d/docker-storage.conf

$ sudo systemctl daemon-reload
$ sudo systemctl restart docker
```

```
$ sudo usermod -aG docker oea
```

