# join

## prerequisites
Our recommendation is a 4 Node Cluster (mininmum 3 Node). For Test and Development you can use a 2 Node Cluster.

1. [User setup](./user.md)
2. [Install Docker](./docker.md)
3. [Install GlusterFS](./glusterfs.md)
3. [Firewall configuration](../extras/ufw/README.md)

## GlusterFS

```
Node02:~$ export GLUSTERFS_NODE01_FQDN=<Node01_FQDN>
Node02:~$ export GLUSTERFS_NODE01_IP=<Node01_IP>
Node02:~$ export GLUSTERFS_NODE02_FQDN=<Node02_FQDN>
Node02:~$ export GLUSTERFS_NODE02_IP=<Node02_IP>
Node02:~$ export GLUSTERFS_NODE03_FQDN=<Node03_FQDN>
Node02:~$ export GLUSTERFS_NODE03_IP=<Node03_IP>
Node02:~$ export GLUSTERFS_NODE04_FQDN=<Node04_FQDN>
Node02:~$ export GLUSTERFS_NODE04_IP=<Node04_IP>
```

```
Node02:~$ sudo openssl genrsa -out /etc/ssl/glusterfs.key 4096
Node02:~$ sudo chmod -v 600 /etc/ssl/glusterfs.key
Node02:~$ sudo openssl req -new -x509 -days 365 -key /etc/ssl/glusterfs.key -subj "/CN=$GLUSTERFS_NODE02_FQDN" -out /etc/ssl/glusterfs.pem
```

```
Node03:~$ export GLUSTERFS_NODE01_FQDN=<Node01_FQDN>
Node03:~$ export GLUSTERFS_NODE01_IP=<Node01_IP>
Node03:~$ export GLUSTERFS_NODE02_FQDN=<Node02_FQDN>
Node03:~$ export GLUSTERFS_NODE02_IP=<Node02_IP>
Node03:~$ export GLUSTERFS_NODE03_FQDN=<Node03_FQDN>
Node03:~$ export GLUSTERFS_NODE03_IP=<Node03_IP>
Node03:~$ export GLUSTERFS_NODE04_FQDN=<Node04_FQDN>
Node03:~$ export GLUSTERFS_NODE04_IP=<Node04_IP>
```

```
Node03:~$ sudo openssl genrsa -out /etc/ssl/glusterfs.key 4096
Node03:~$ sudo chmod -v 600 /etc/ssl/glusterfs.key
Node03:~$ sudo openssl req -new -x509 -days 365 -key /etc/ssl/glusterfs.key -subj "/CN=$GLUSTERFS_NODE03_FQDN" -out /etc/ssl/glusterfs.pem
```

```
Node04:~$ export GLUSTERFS_NODE01_FQDN=<Node01_FQDN>
Node04:~$ export GLUSTERFS_NODE01_IP=<Node01_IP>
Node04:~$ export GLUSTERFS_NODE02_FQDN=<Node02_FQDN>
Node04:~$ export GLUSTERFS_NODE02_IP=<Node02_IP>
Node04:~$ export GLUSTERFS_NODE03_FQDN=<Node03_FQDN>
Node04:~$ export GLUSTERFS_NODE03_IP=<Node03_IP>
Node04:~$ export GLUSTERFS_NODE04_FQDN=<Node04_FQDN>
Node04:~$ export GLUSTERFS_NODE04_IP=<Node04_IP>
```

```
Node04:~$ sudo openssl genrsa -out /etc/ssl/glusterfs.key 4096
Node04:~$ sudo chmod -v 600 /etc/ssl/glusterfs.key
Node04:~$ sudo openssl req -new -x509 -days 365 -key /etc/ssl/glusterfs.key -subj "/CN=$GLUSTERFS_NODE04_FQDN" -out /etc/ssl/glusterfs.pem
```

Concatenate all pem files
```
Node04:~$ scp root@$GLUSTERFS_NODE01_FQDN:/etc/ssl/glusterfs.ca glusterfs.ca
Node04:~$ scp root@$GLUSTERFS_NODE02_FQDN:/etc/ssl/glusterfs.pem glusterfs.pem.$GLUSTERFS_NODE02_FQDN
Node04:~$ scp root@$GLUSTERFS_NODE03_FQDN:/etc/ssl/glusterfs.pem glusterfs.pem.$GLUSTERFS_NODE03_FQDN
Node04:~$ sudo cat glusterfs.pem.$GLUSTERFS_NODE02_FQDN >> glusterfs.ca
Node04:~$ sudo cat glusterfs.pem.$GLUSTERFS_NODE03_FQDN >> glusterfs.ca
Node04:~$ sudo cat /etc/ssl/glusterfs.pem >> glusterfs.ca
Node04:~$ scp glusterfs.ca root@$GLUSTERFS_NODE01_FQDN:/etc/ssl/glusterfs.ca
Node04:~$ scp glusterfs.ca root@$GLUSTERFS_NODE02_FQDN:/etc/ssl/glusterfs.ca
Node04:~$ scp glusterfs.ca root@$GLUSTERFS_NODE03_FQDN:/etc/ssl/glusterfs.ca
Node04:~$ sudo mv -v glusterfs.ca /etc/ssl/glusterfs.ca
```

Enable secure-access on all Nodes
```
Node04:~$ sudo touch /var/lib/glusterd/secure-access
Node04:~$ sudo mkdir -pv /opt/oea/glusterfs/oea
Node04:~$ sudo systemctl restart glusterd
```
```
Node03:~$ sudo touch /var/lib/glusterd/secure-access
Node03:~$ sudo mkdir -pv /opt/oea/glusterfs/oea
Node03:~$ sudo systemctl restart glusterd
```
```
Node02:~$ sudo touch /var/lib/glusterd/secure-access
Node02:~$ sudo mkdir -pv /opt/oea/glusterfs/oea
Node02:~$ sudo systemctl restart glusterd
```

```
Node01:~$ export GLUSTERFS_NODE01_FQDN=<Node01_FQDN>
Node01:~$ export GLUSTERFS_NODE01_IP=<Node01_IP>
Node01:~$ export GLUSTERFS_NODE02_FQDN=<Node02_FQDN>
Node01:~$ export GLUSTERFS_NODE02_IP=<Node02_IP>
Node01:~$ export GLUSTERFS_NODE03_FQDN=<Node03_FQDN>
Node01:~$ export GLUSTERFS_NODE03_IP=<Node03_IP>
```

```
Node01:~$ sudo systemctl restart glusterd
```

```
Node01:~$ sudo gluster peer probe $GLUSTERFS_NODE02_FQDN, $GLUSTERFS_NODE03_FQDN
Node01:~$ sudo gluster peer status
```

```
Node01:~$ sudo gluster volume set oea auth.allow $GLUSTERFS_NODE01_IP,$GLUSTERFS_NODE02_IP,$GLUSTERFS_NODE03_IP
Node01:~$ sudo gluster volume set oea auth.ssl-allow "$GLUSTERFS_NODE01_FQDN,$GLUSTERFS_NODE02_FQDN,$GLUSTERFS_NODE03_FQDN"
```

```
Node01:~$ sudo gluster volume add-brick oea replica 2 $GLUSTERFS_NODE02_FQDN:/opt/oea/glusterfs/oea
Node01:~$ sudo gluster volume add-brick oea replica 3 $GLUSTERFS_NODE03_FQDN:/opt/oea/glusterfs/oea
Node01:~$ sudo gluster volume heal oea full
Node01:~$ sudo gluster volume heal oea info
```

```
Node02:~$ sudo mkdir -pv /opt/oea/mnt/glusterfs
Node02:~$ echo "echo 'localhost:/oea /opt/oea/mnt/glusterfs glusterfs defaults,_netdev,noauto,x-systemd.automount 0 0' >> /etc/fstab" | sudo -s
Node02:~$ sudo mount -a
Node02:~$ sudo shutdown -r now
```

```
Node03:~$ sudo mkdir -pv /opt/oea/mnt/glusterfs
Node03:~$ echo "echo 'localhost:/oea /opt/oea/mnt/glusterfs glusterfs defaults,_netdev,noauto,x-systemd.automount 0 0' >> /etc/fstab" | sudo -s
Node03:~$ sudo mount -a
Node03:~$ sudo shutdown -r now
```

```
Node01:~$ sudo shutdown -r now
```

### renew certificate

```
Node02:~$ openssl x509 -enddate -noout -in /etc/ssl/glusterfs.ca
```

```
Node02:~$ sudo systemctl stop glusterd
```

```
Node02:~$ sudo openssl req -new -x509 -days 365 -key /etc/ssl/glusterfs.key -subj "/CN=$GLUSTERFS_NODE02_FQDN" -out /etc/ssl/glusterfs.pem
Node02:~$ scp root@$GLUSTERFS_NODE01_FQDN:/etc/ssl/glusterfs.ca .
Node02:~$ sudo cat /etc/ssl/glusterfs.pem >> glusterfs.ca
Node02:~$ scp glusterfs.ca root@$GLUSTERFS_NODE01_FQDN:/etc/ssl/glusterfs.ca
Node02:~$ sudo mv -v glusterfs.ca /etc/ssl/glusterfs.ca
```

```
Node02:~$ sudo systemctl start glusterd
```

### benchmark

#### local

```
Node01:~$ cd /opt/oea/mnt/
Node01:~$ sudo mkdir local
Node01:~$ sudo dd if=/dev/zero of=/opt/oea/mnt/local/benchmark_local.img bs=1G count=1 oflag=dsync
1+0 records in
1+0 records out
1073741824 bytes (1.1 GB, 1.0 GiB) copied, 2.20512 s, 487 MB/s
```

#### glusterfs

```
Node01:~$ sudo dd if=/dev/zero of=/opt/oea/mnt/glusterfs/benchmark_glusterfs.img bs=1G count=1 oflag=dsync
1+0 records in
1+0 records out
1073741824 bytes (1.1 GB, 1.0 GiB) copied, 35.9641 s, 29.9 MB/s
```

##### w/ extra config gluster volume

```
Node01:~$ sudo dd if=/dev/zero of=/opt/oea/mnt/glusterfs/benchmark_glusterfs.img bs=1G count=1 oflag=dsync
1+0 records in
1+0 records out
1073741824 bytes (1.1 GB, 1.0 GiB) copied, 33.1838 s, 32.4 MB/s
```

#### cleanup

```
Node01:~$ sudo rm -v /opt/oea/mnt/local/benchmark_local.img
removed '/opt/oea/mnt/local/benchmark_local.img'
Node01:~$ sudo rm -v /opt/oea/mnt/glusterfs/benchmark_glusterfs.img
removed '/opt/oea/mnt/glusterfs/benchmark_glusterfs.img'
```

## Docker swarm

[Open protocols and ports between the hosts](https://docs.docker.com/engine/swarm/swarm-tutorial/#open-protocols-and-ports-between-the-hosts):
```
Open protocols and ports between the hosts

The following ports must be available. On some systems, these ports are open by default.

    TCP port 2377 for cluster management communications
    TCP and UDP port 7946 for communication among nodes
    UDP port 4789 for overlay network traffic

If you are planning on creating an overlay network with encryption (--opt encrypted), you will also need to ensure ip protocol 50 (ESP) traffic is allowed.
```

### deployment

#### ssl certificate (for all Proxy- and Webservice)

```
Node02:~# mkdir -pv /opt/oea/data/etc/nginx/ssl
Node02:~# cp -pv /path/to/nginx.key /path/to/nginx.crt /opt/oea/data/etc/nginx/ssl
Node02:~# tree /opt/oea/data/etc
opt/oea/data/etc
└── nginx
    └── ssl
        ├── nginx.crt
        └── nginx.key

3 directories, 2 files
```
#### oearegistry

```
Node02:~$ export DOCKER_REGISTRY=localhost:5443
Node02:~$ export DOCKER_REGISTRY_FQDN=<Node02_FQDN>:5443
```

##### bootstrap node

```
Node02:~$ export DOCKER_REGISTRY_FQDN=<Node01_FQDN>:5443
Node02:~$ docker login --username=user $DOCKER_REGISTRY_FQDN
Password: 
Login Succeeded
Node02:~$ docker pull $DOCKER_REGISTRY_FQDN/regproxy:current
Node02:~$ docker tag $DOCKER_REGISTRY_FQDN/regproxy:current $DOCKER_REGISTRY/regproxy:current
Node02:~$ docker rmi $DOCKER_REGISTRY_FQDN/regproxy:current
Node02:~$ docker pull $DOCKER_REGISTRY_FQDN/registry:current
Node02:~$ docker tag $DOCKER_REGISTRY_FQDN/registry:current $DOCKER_REGISTRY/registry:current
Node02:~$ docker rmi $DOCKER_REGISTRY_FQDN/registry:current
Node02:~$ docker images
REPOSITORY                TAG                 IMAGE ID            CREATED             SIZE
localhost:5443/regproxy   current             1de1b899606e        47 hours ago        303MB
localhost:5443/registry   current             751f286bc25e        12 days ago         33.2MB
Node02:~$ rm -rf .docker/
Node02:~$ export DOCKER_REGISTRY_FQDN=<Node02_FQDN>:5443
```

#### oeaplatform

```
Node02:~# groupadd -r -g 9000 dkr && useradd -r -u 9000 -g 9000 dkr
```

```
Node02:~# cat /proc/sys/vm/max_map_count
65530
Node02:~# sysctl -w vm.max_map_count=262144
Node02:~# cat /proc/sys/vm/max_map_count
262144
Node02:~# echo 'vm.max_map_count = 262144' >> /etc/sysctl.conf
```

##### additional node

```
Node02:~# mkdir -pv /opt/oea/data/oeaplatform/index/usr/share/opensearch/data
Node02:~# mkdir -pv /opt/oea/data/oeaplatform/index/var/log/opensearch
Node02:~# chown -v dkr:dkr /opt/oea/data/oeaplatform/index/usr/share/opensearch/data
Node02:~# chown -v dkr:dkr /opt/oea/data/oeaplatform/index/var/log/opensearch
Node02:~# tree /opt/oea/data/oeaplatform/index/
/opt/oea/data/oeaplatform/index/
├── usr
│   └── share
│       └── opensearch
│           └── data
└── var
    └── log
        └── opensearch

7 directories, 0 files
```

### join

```
Node01:~$ docker swarm join-token manager
To add a manager to this swarm, run the following command:

    docker swarm join \
    --token SWMTKN-1-1qr49apslclv17793kh681sjfox3linq2ozzulegw5lrhuryuy-4s9bdh7bx85nfmnbe2xdinks1 \
    192.168.0.10:2377

```

```
Node02:~$ docker swarm join \
>     --token SWMTKN-1-1qr49apslclv17793kh681sjfox3linq2ozzulegw5lrhuryuy-4s9bdh7bx85nfmnbe2xdinks1 \
>     192.168.0.10:2377
This node joined a swarm as a manager.
```

```
Node02:~$ docker service ls
ID                  NAME                         MODE                REPLICAS            IMAGE                                  PORTS
w90u3usbni50        oeaplatform_index            global              4/4                 localhost:5443/index:current
lcmrmys5b0z0        oeaplatform_metaharvest      replicated          4/4                 localhost:5443/metaharvest:current
c6d4wp0s02dp        oeaplatform_metaingest       replicated          4/4                 localhost:5443/metaingest:current
uy2il6ygom3b        oeaplatform_monitor          replicated          1/1                 localhost:5443/monitor:current
w9bmmmiayw88        oeaplatform_mq               replicated          1/1                 localhost:5443/mq:current
3huakp7pgntm        oeaplatform_stats            replicated          1/1                 localhost:5443/stats:current
j2q1wp2s1awj        oeaplatform_webserver        global              4/4                 localhost:5443/webserver:current
k7ng4r9a2pky        oearegistry_registry         replicated          1/1                 localhost:5443/registry:current
v6fnsatrtjjr        oearegistry_regproxy         global              4/4                 localhost:5443/regproxy:current
```

### how to remove a node

demote -> drain -> leave -> remove
```
Node01:~$ docker node demote Node02
Manager Node02 demoted in the swarm.
```

```
Node01:~$ docker node update --availability drain Node02
Node02
```

```
Node02:~$ docker swarm leave
Node left the swarm.
```

```
Node01:~$ docker node rm Node02
Node02
```

