# Oeaplatform

```
# mkdir -pv /opt/oea/data/etc/nginx/ssl
# cp -pv /path/to/nginx.key /path/to/nginx.crt /opt/oea/data/etc/nginx/ssl
# tree /opt/oea/data/etc
/opt/oea/data/etc
└── nginx
    └── ssl
        ├── nginx.crt
        └── nginx.key

3 directories, 2 files
```

```
# groupadd -r -g 9000 dkr && useradd -r -u 9000 -g 9000 dkr
```

Important settings for OpenSearch:

```
# cat /proc/sys/vm/max_map_count
65530
# sysctl -w vm.max_map_count=262144
# cat /proc/sys/vm/max_map_count
262144
# echo 'vm.max_map_count = 262144' >> /etc/sysctl.conf
```

## Initial Node

```
# mkdir -pv /opt/oea/data/oeaplatform/index/usr/share/opensearch/data
# mkdir -pv /opt/oea/data/oeaplatform/index/usr/share/opensearch/logs
# chown -v dkr:dkr /opt/oea/data/oeaplatform/index/usr/share/opensearch/data
# chown -v dkr:dkr /opt/oea/data/oeaplatform/index/usr/share/opensearch/logs
# tree /opt/oea/data/oeaplatform/index/
/opt/oea/data/oeaplatform/index/
├── usr
│   └── share
│       └── opensearch
│           └── data
└── usr
    └── share
        └── opensearch
            └── logs

8 directories, 0 files

# mkdir -pv /opt/oea/data/oeaplatform/stats/var/log/opensearch-dashboards
# chown -v dkr:dkr /opt/oea/data/oeaplatform/stats/var/log/opensearch-dashboards
# tree /opt/oea/data/oeaplatform/stats
/opt/oea/data/oeaplatform/stats
└── var
    └── log
        └── opensearch-dashboards

# mkdir -pv /opt/oea/mnt/glusterfs/oeaplatform/webserver/var/log/nginx
# mkdir -pv /opt/oea/mnt/glusterfs/oeaplatform/mq/var/lib/rabbitmq
# mkdir -pv /opt/oea/mnt/glusterfs/oeaplatform/mq/var/log/rabbitmq
# mkdir -pv /opt/oea/mnt/glusterfs/oeaplatform/metaharvest/home/perl/metaharvest/log
# mkdir -pv /opt/oea/mnt/glusterfs/oeaplatform/metaharvest/home/perl/metaharvest/tmp
# mkdir -pv /opt/oea/mnt/glusterfs/oeaplatform/metaingest/home/perl/metaingest/log
# chown -v dkr:dkr /opt/oea/mnt/glusterfs/oeaplatform/mq/var/lib/rabbitmq
# chown -v dkr:dkr /opt/oea/mnt/glusterfs/oeaplatform/mq/var/log/rabbitmq
# chown -v dkr:dkr /opt/oea/mnt/glusterfs/oeaplatform/metaharvest/home/perl/metaharvest/log
# chown -v dkr:dkr /opt/oea/mnt/glusterfs/oeaplatform/metaharvest/home/perl/metaharvest/tmp
# chown -v dkr:dkr /opt/oea/mnt/glusterfs/oeaplatform/metaingest/home/perl/metaingest/log
# tree /opt/oea/mnt/glusterfs/oeaplatform/
/opt/oea/mnt/glusterfs/oeaplatform/
├── metaharvest
│   └── home
│       └── perl
│           └── metaharvest
│               ├── log
│               └── tmp
├── metaingest
│   └── home
│       └── perl
│           └── metaingest
│               └── log
├── mq
│   └── var
│       ├── lib
│       │   └── rabbitmq
│       └── log
│           └── rabbitmq
└── webserver
    └── var
        └── log
            └── nginx
```

```
# mkdir -pv /opt/oea/mnt/glusterfs/oeaplatform/webserver/etc/nginx/auth_basic
# echo -n 'admin:' >> /opt/oea/mnt/glusterfs/oeaplatform/webserver/etc/nginx/auth_basic/.htpasswd
# openssl passwd -apr1 >> /opt/oea/mnt/glusterfs/oeaplatform/webserver/etc/nginx/auth_basic/.htpasswd
Password: 
Verifying - Password: 
# tree -a /opt/oea/mnt/glusterfs/oeaplatform/webserver/
/opt/oea/mnt/glusterfs/oeaplatform/webserver/
├── etc
│   └── nginx
│       └── auth_basic
│           └── .htpasswd
└── var
    └── log
        └── nginx

6 directories, 1 file
```

```
# mkdir -pv /opt/oea/mnt/glusterfs/oeaplatform/mq/etc/rabbitmq
$ export RABBITMQ_ADMIN_PASSWORD=$(pwgen -sv -N 1 32)
$ export RABBITMQ_PRODUCER_PASSWORD=$(pwgen -sv -N 1 32)
$ export RABBITMQ_CONSUMER_PASSWORD=$(pwgen -sv -N 1 32)
$ export RABBITMQ_ADMIN_PASSWORD_HASH=$( \
  SALT=$(pwgen -s -N 1 4 | tr -d '\n' | od -An -t x | tr -d '[:space:]') \
  && echo -n "$SALT$(echo -n "$SALT$(echo -n $RABBITMQ_ADMIN_PASSWORD | xxd -pu)" | xxd -r -pu | sha256sum | cut -d ' ' -f1)" | xxd -r -pu | base64 \
)
$ export RABBITMQ_PRODUCER_PASSWORD_HASH=$( \
  SALT=$(pwgen -s -N 1 4 | tr -d '\n' | od -An -t x | tr -d '[:space:]') \
  && echo -n "$SALT$(echo -n "$SALT$(echo -n $RABBITMQ_PRODUCER_PASSWORD | xxd -pu)" | xxd -r -pu | sha256sum | cut -d ' ' -f1)" | xxd -r -pu | base64 \
)
$ export RABBITMQ_CONSUMER_PASSWORD_HASH=$( \
  SALT=$(pwgen -s -N 1 4 | tr -d '\n' | od -An -t x | tr -d '[:space:]') \
  && echo -n "$SALT$(echo -n "$SALT$(echo -n $RABBITMQ_CONSUMER_PASSWORD | xxd -pu)" | xxd -r -pu | sha256sum | cut -d ' ' -f1)" | xxd -r -pu | base64 \
)
$ sudo envsubst < rabbitmq/config/definitions.json.tmpl > /opt/oea/mnt/glusterfs/oeaplatform/mq/etc/rabbitmq/definitions.json
# tree /opt/oea/mnt/glusterfs/oeaplatform/mq/etc/rabbitmq/
/opt/oea/mnt/glusterfs/oeaplatform/mq/etc/rabbitmq/
└── definitions.json

0 directories, 1 file
$ echo $RABBITMQ_PRODUCER_PASSWORD | docker secret create mq_producer_pass -
xs1ui6j7pskyfqr77ibei36cv
$ echo $RABBITMQ_CONSUMER_PASSWORD | docker secret create mq_consumer_pass -
jjb6hu93m5exoscp3e6gwa27a
$ docker secret ls
ID                          NAME                DRIVER              CREATED             UPDATED
jjb6hu93m5exoscp3e6gwa27a   mq_consumer_pass                        14 seconds ago      14 seconds ago
xs1ui6j7pskyfqr77ibei36cv   mq_producer_pass                        19 seconds ago      19 seconds ago
```

```
# cp -r metaharvest/perl/etc /opt/oea/mnt/glusterfs/oeaplatform/metaharvest/home/perl/metaharvest/etc
# tree /opt/oea/mnt/glusterfs/oeaplatform/metaharvest/home/perl/metaharvest/etc/
/opt/oea/mnt/glusterfs/oeaplatform/metaharvest/home/perl/metaharvest/etc/
├── daemon
│   └── config.yml
└── jobs
    ├── payload.yml
    └── sanity.yml

2 directories, 3 files
```

```
# cp -r metaingest/perl/etc /opt/oea/mnt/glusterfs/oeaplatform/metaingest/home/perl/metaingest/etc
# tree /opt/oea/mnt/glusterfs/oeaplatform/metaingest/home/perl/metaingest/etc/
/opt/oea/mnt/glusterfs/oeaplatform/metaingest/home/perl/metaingest/etc/
├── daemon
│   └── config.yml
├── queues
│   ├── payload.yml
│   └── sanity.yml
```

### Build

```
$ ./build_fresh_oeaplatform.sh
```

Check the pushed images on your private registry:
```
$ curl -XGET -u user https://$DOCKER_REGISTRY_FQDN/v2/_catalog
Enter host password for user 'user':
{"repositories":["index","metaharvest","metaingest","mq","registry","regproxy","stats","webserver"]}
```

### Stack deploy and remove

```
$ docker stack deploy --detach=true --prune --with-registry-auth -c docker-compose.yml oeaplatform
Ignoring unsupported options: build

Creating network oeaplatform_frontend
Creating network oeaplatform_backend
Creating service oeaplatform_metaharvest
Creating service oeaplatform_metaingest
Creating service oeaplatform_webserver
Creating service oeaplatform_index
Creating service oeaplatform_stats
Creating service oeaplatform_mq
Creating service oeaplatform_frontend-client
Creating service oeaplatform_frontend-server
```

```
docker service ls|grep oeaplatform
ryb9h4p22jtb   oeaplatform_frontend-client   global       4/4        localhost:5443/frontend-client:current
uvh5hb0hhp7y   oeaplatform_frontend-server   global       4/4        localhost:5443/frontend-server:current
26nlgu8rmenq   oeaplatform_index             global       4/4        localhost:5443/index:current
kblqck36ezo8   oeaplatform_metaharvest       replicated   7/7        localhost:5443/metaharvest:current
n4f2a0t70r21   oeaplatform_metaingest        replicated   7/7        localhost:5443/metaingest:current
pbn3hsvhc7dq   oeaplatform_mq                replicated   1/1        localhost:5443/mq:current
m8zsl6g9rm91   oeaplatform_stats             replicated   1/1        localhost:5443/stats:current
zq1w3fpwqtis   oeaplatform_webserver         global       4/4        localhost:5443/webserver:current
```

* [Frontend](https://<Node01_FQDN>:443)
* [RabbitMQ](https://<Node01_FQDN>:15443)
* [Dashboards](https://<Node01_FQDN>:8443/status)

```
$ docker stack rm oeaplatform
Removing service oeaplatform_index
Removing service oeaplatform_metaharvest
Removing service oeaplatform_metaingest
Removing service oeaplatform_mq
Removing service oeaplatform_stats
Removing service oeaplatform_webserver
Removing service oeaplatform_frontend-client
Removing service oeaplatform_frontend-server
Removing network oeaplatform_backend
Removing network oeaplatform_frontend
```

### Init Opensearch
create index for each repo, alias and vocabs
#### Deploy script and configuarion
Go to the folder opensearch and tar.gz the folder `custom` and copy into the running container `index`
```
$ cd opensearch
$ tar -cvzf custom.tgz custom
### copy custom.tgz into the running container
$ docker cp custom.tgz $(docker ps |grep 'index:'| awk ' {print $1}'):/home/custom.tgz
```
#### Run script in container
start a bash of container `index` as user root (option -u 0)
```
$ docker exec -it -u 0 $(docker ps |grep 'index:'| awk ' {print $1}') bash
```
Extract the `custom.tgz` and cd into folder `custom`
```
$ cd /home
$ tar -zxf custom.tgz
$ cd custom
$ ./build_fresh_index.sh
```

### Init RabbitMQ

```
$ docker exec -ti oeaplatform_mq.1.25pjrg5k4bnmic35topp1s6zd \
  python3 /opt/rabbitmqadmin -u admin -p $RABBITMQ_ADMIN_PASSWORD \
  declare queue name=<index_01> durable=true auto_delete=false
queue declared
$ docker exec -ti oeaplatform_mq.1.25pjrg5k4bnmic35topp1s6zd \
  python3 /opt/rabbitmqadmin -u admin -p $RABBITMQ_ADMIN_PASSWORD \
  list queues
+------------+----------+
|    name    | messages |
+------------+----------+
| <index_01> | 0        |
+------------+----------+
```
List of message queues to declare:
- oer-portal.uni-graz.at
- oer-repo.uibk.ac.at
- oer.fh-salzburg.ac.at
- phaidra.univie.ac.at
- repository.tugraz.at
- gecko.aau.at
- door.donau-uni.ac.at
- phaidra.fh-kaernten.at

### Configuration
#### Metaharvest
The harvester has the follwoing yml configuration files
```
$ tree etc
etc
├── daemon
│   └── config.yml
└── jobs
    ├── payload.yml
    └── sanity.yml
```
##### config.yml
Configuration of the daemon.
```yaml
#
# YAML Config
# regarding daemon
#

#
# CTRL
ctrl:
  sleep: 3 # seconds between loops; default 10
  verbosity: 1 # <0|1|2>; default 2
  debug: 0 # <0|1>; default 1
  dryrun: 0 # <0|1>; default 0
  log:
    path: 'log'
    filename: 'daemon.log'

#
# Jobs
jobs:
  lock:
    path: 'tmp'
    ext: '.lock'
```
##### payload.yml
In `payload.yml` the deamon gets the job details of each repository.
```yaml
#
# YAML Config
# regarding payload
#

#
# Jobs
jobs:
  <repo_id>:
    type: 'OAIHarvest_LOM'
    cfg:
      verbosity: 2 # <0|1|2>; default 2
      debug: 1 # <0|1>; default 1
      log:
        path: 'log'
        filename: 'oer-repo.uibk.ac.at.log'
      mq:
        host: 'mq'
        port: 5672
        user: 'producer'
        pass: '/run/secrets/mq_producer_pass'
        vhost: '/'
        routing_key: '<message_queue_id>'
      uri:
        scheme: 'https'
        authority : '//<FQDN>'
        path: '/edu-sharing/eduservlet/oai/provider'
        parameters:
          prefix: 'lom'
          from: ''
          until: ''
          set: 'default'
          handler: '<hadler_identifier>'
      sleep:
        token: 0.001
        post: 321
        pre: 1
```

| Key | Value |
|-----|-------|
| <repo_id> | Identifies the repository |
| type | Supported Values:<br>- <b>OAIHarvest_LOM</b><br>- <b>OAIHarvest_DC</b> (Not used in oerhub-ce) |
| mq.routing_key | <i><message_queue_id></i> Name of Queue |
| uri.path | Path:<br>- <b>/edu-sharing/eduservlet/oai/provider</b> (Repos based on edu-sharing)<br>- <b>/oai2d</b> (Repos based on Invenio)<br>- <b>/api/oai</b> (Repos based on Phaidra) |
| uri.parameters.handler | <i><handler_identifier></i> Supported Values:<br>- <b>OAI_LOM_edusharing</b> (Repos based on edu-sharing and Phaidra)<br>- <b>OAI_LOM_invenio</b> (Repos based on Invenio) |

Example:
```yaml
#
# YAML Config
# regarding payload
#

#
# Jobs
jobs:
  oer-repo.uibk.ac.at:
    type: 'OAIHarvest_LOM'
    cfg:
      verbosity: 2 # <0|1|2>; default 2
      debug: 1 # <0|1>; default 1
      log:
        path: 'log'
        filename: 'oer-repo.uibk.ac.at.log'
      mq:
        host: 'mq'
        port: 5672
        user: 'producer'
        pass: '/run/secrets/mq_producer_pass'
        vhost: '/'
        routing_key: 'oer-repo.uibk.ac.at'
      uri:
        scheme: 'https'
        authority : '//oer-repo.uibk.ac.at'
        path: '/edu-sharing/eduservlet/oai/provider'
        parameters:
          prefix: 'lom'
          from: ''
          until: ''
          set: 'default'
          handler: 'OAI_LOM_edusharing'
      sleep:
        token: 0.001
        post: 321
        pre: 1
```

#### Metaingest
The Ingester has the follwoing yml configuration files
```
$ tree etc/
etc/
├── daemon
│   └── config.yml
├── queues
│   ├── payload.yml
│   └── sanity.yml
├── sources
    ├── vocabs
    └── config.yml
```
##### config.yml
Configuration of the daemon.
```yaml
#
# YAML Config
# regarding daemon
#

#
# CTRL
ctrl:
  # sleep: 1 # seconds between resurrection loops; default 10
  verbosity: 1 # <0|1|2>; default 2
  debug: 0 # <0|1>; default 1
  dryrun: 0 # <0|1>; default 0
  log:
    path: 'log'
    filename: 'daemon.log'
```
##### payload.yml
In `payload.yml` the deamon gets the job details of each repository.
```yaml
#
# YAML Config
# regarding payload
#

#
# CTRL
ctrl:
  verbosity: 0 # <0|1|2>; default 2
  debug: 0 # <0|1>; default 1
  log:
    path: 'log'
    filename: 'app.log'
  mq:
    host: 'mq'
    port: 5672
    user: 'consumer'
    pass: '/run/secrets/mq_consumer_pass'
    vhost: '/'
    prefetch_count: 1 # <42>; default 1
  objects:
    max: 0 # <42>; 0:all, <42>:such many
  sleep:
    batch: 0.001 # seconds to sleep between receiving messages
    pre: 2 # seconds to sleep before workout of queues

#
# Queues
queues:
  <message_queue_id>:
    type: 'OAIIngest_LOM_edusharing'
    cfg:
      verbosity: 1 # <0|1|2>; default 2
      debug: 0 # <0|1>; default 1
      log:
        path: 'log'
        filename: 'oer-repo.uibk.ac.at.log'
      uri:
        scheme: 'http'
        authority : '//<service_name>:9200'
        path: '/<repo_index_name>'
      ingest:
        age: '1d'
```

| Key | Value |
|-----|-------|
| <i><message_queue_id></i> | Name of Queue |
| type | Supported Values:<br>- <b>OAIIngest_LOM_edusharing</b> (Repos based on edu-sharing and Phaidra)<br>- <b>OAIIngest_LOM_invenio</b> (Repos based on Invenio) |
| uri.authority | <i><service_name></i> is the Service Name <b>index</b> used by Docker Container |
| uri.path | <i><repo_index_name></i> is the index name in OpenSearch used for the Repo |
| ingest.age | Age of an Object before removing it from Index. Supported Values:<br>- <b>Xd</b> X Days (Example: 1d)<br>- <b>Ys</b> Y Seconds (Example: 3600s)|

Example queues section:
```yaml
queues:
  oer-repo.uibk.ac.at:
    type: 'OAIIngest_LOM_edusharing'
    cfg:
      verbosity: 1 # <0|1|2>; default 2
      debug: 0 # <0|1>; default 1
      log:
        path: 'log'
        filename: 'oer-repo.uibk.ac.at.log'
      uri:
        scheme: 'http'
        authority : '//index:9200'
        path: '/oer-repo.uibk.ac.at'
      ingest:
        age: '1d'
```        
### Development Hints
#### Frontend

The application frontend has a server (search API) and client (web application) part
```
$ ./frontend/server/
$ ./frontend/client/

```


```
$ docker service update --force oeaplatform_frontend-server
oeaplatform_frontend-server
$ docker service update --force oeaplatform_frontend-client
oeaplatform_frontend-client
```

Libraries utilized:
* [Vue.js](https://vuejs.org/)
* [NuxtJS/](https://nuxtjs.org/)
* [tailwind](https://tailwindcss.nuxtjs.org/)

#### Metaharvest
How to exec a the test-script for metaharvest:
```
$ vim metaharvest/perl/daemon.pl
$ docker exec oeaplatform_metaharvest.1.jh5hpk0zf05ygscek34ofzjxr /home/perl/metaharvest/t/run.sh
/home/perl/metaharvest/t/00_compile.t .. ok
[..]
Result: PASS
```

```
$ docker service update --force oeaplatform_metaharvest
oeaplatform_metaharvest
```

#### Metaingest
How to exec a the test-script for metaingest:
```
$ vim metaingest/perl/daemon.pl
$ docker exec oeaplatform_metaingest.1.u77atafrsk3bjudku6anr3mn3 /home/perl/metaingest/t/run.sh
/home/perl/metaingest/t/00_compile.t .. ok
[..]
Result: PASS
```

```
$ docker service update --force oeaplatform_metaingest
oeaplatform_metaingest
```

ÖFOS classification extracted from [STATISTIK AUSTRIA/Klassifikationsdatenbank](http://www.statistik.at/KDBWeb/kdb_DownloadsAnzeigen.do?AUFRUF=klass&KLASSID=10515&KLASSNAME=__FOS).

### Rebuild

```

$ ./rebuild.sh -b metaharvest
$ ./rebuild.sh -b metaingest
$ ./rebuild.sh -b webserver
$ ./rebuild.sh -b mq
$ ./rebuild.sh -b index
$ ./rebuild.sh -b stats
$ ./rebuild.sh -b frontend-server
$ ./rebuild.sh -b frontend-client
```

```
$ curl -XGET -u user https://$DOCKER_REGISTRY_FQDN/v2/_catalog
Enter host password for user 'user':
{"repositories":["index","metaharvest","metaingest","mq","registry","regproxy","stats","webserver","frontend-client","frontend-server"]}
$ curl -XGET -u user https://$DOCKER_REGISTRY_FQDN/v2/index/tags/list
Enter host password for user 'user':
{"name":"index","tags":["current"]}
```
